{% extends 'id/id_base.html' %}
{% load static %}


{% block content %}
    <section>
        <div class="spacer no-spacer">
            <div class="shadow p-30">
                <div class="text-center mb-5">
                    <img class="img-fluid mb-2" src="{% static 'images/common/logos/logo-blue.png' %}" width="100"/>
                    <div class="h3 c-blue">
                        Gabung bersama 200+ kontributor citizen science
                    </div>
                </div>
                <form action="{% url 'backend:signup' %}" method="post">
                    {% csrf_token %}
                    <div class="row g-3">
                        <div class="col-md-12">
                            <label for="username" class="form-label">
                                Username <span class="c-red">*</span>
                            </label>
                            <div class="input-group">
                                <input type="text" class="form-control" name="username" id="username" required>
                                <div id="usernameFeedback" class="feedback"></div>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <label for="first_name" class="form-label">
                                Nama Depan <span class="c-red">*</span>
                            </label>
                            <input type="text" class="form-control" name="first_name" id="first_name" required>
                        </div>
                        <div class="col-md-6">
                            <label for="last_name" class="form-label">
                                Nama Belakang <span class="c-red">*</span>
                            </label>
                            <input type="text" class="form-control" name="last_name" id="last_name" required>
                        </div>
                        <div class="col-md-12">
                            <label for="job" class="form-label">
                                Pekerjaan <span class="c-red">*</span>
                            </label>
                            <input type="text" class="form-control" name="job" id="job" required>
                        </div>
                        <div class="col-md-6">
                            <label for="phone" class="form-label">
                                No Telepon <span class="c-red">*</span>
                            </label>
                            <input type="text" class="form-control" name="phone" id="phone" required>
                        </div>
                        <div class="col-md-6">
                            <label for="age" class="form-label">
                                Tanggal Lahir <span class="c-red">*</span>
                            </label>
                            <input type="date" class="form-control" name="birthday" id="birthday" required>
                        </div>
                        <div class="col-md-12">
                            <label for="email" class="form-label">
                                Email <span class="c-red">*</span>
                            </label>
                            <input type="email" class="form-control" name="email" id="email" required>
                        </div>
                        <div class="col-md-12">
                            <label for="email" class="form-label">
                                Bahasa <span class="c-red">*</span>
                            </label>
                            <select class="form-select" name="language" id="language">
                                <option value="en">English</option>
                                <option value="id">Bahasa Indonesia</option>
                            </select>
                        </div>
                        <div class="col-md-12">
                            <label for="password" class="form-label">
                                Kata Sandi <span class="c-red">*</span>
                            </label>
                            <div class="input-group mb-3">
                                <input type="password" class="form-control" name="password" id="password" required>
                                <span id="password_icon" class="input-group-text">
                                    <i class="bi bi-eye"></i>
                                </span>
                                <div id="password_feedback" class="feedback"></div>
                            </div>
                        </div>
                        <div class="col-md-12">
                            <label for="password" class="form-label">
                                Konfirmasi Kata Sandi <span class="c-red">*</span>
                            </label>
                            <div class="input-group mb-3">
                                <input type="password" class="form-control" name="confirm_password"
                                       id="confirm_password" required>
                                <span id="confirm_password_icon" class="input-group-text">
                                    <i class="bi bi-eye"></i>
                                </span>
                                <div id="confirm_password_feedback" class="feedback"></div>
                            </div>
                        </div>
                        <div class="col-12">
                            <div class="form-check">
                                <input class="form-check-input" type="checkbox" name="check" id="check">
                                <label class="form-check-label" for="check">
                                    Saya setuju dengan
                                    <a class="c-lightblue-2 no-link fw-600" target="_blank"
                                       href="{% url 'frontend:report_tna' %}">
                                        Syarat dan Persetujuan
                                    </a>
                                </label>
                            </div>
                        </div>
                        <div class="col-md-12 text-center mt-5">
                            <button id="submit" type="submit" class="btn btn-primary" disabled>Daftar</button>
                        </div>
                        <div class="col-md-12 text-center">
                            Sudah menjadi kontributor?
                            <a class="c-lightblue-2 no-link fw-600" href="{% url 'frontend:login' %}">Masuk</a>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </section>
{% endblock %}

{% block js %}
    <script type="text/javascript">
        $(document).ready(function () {
            let username = $('#username');
            let usernameFeedback = $('#usernameFeedback');

            let password = $('#password');
            let passwordFeedback = $('#password_feedback');
            let confirmPassword = $('#confirm_password');
            let confirmPasswordFeedback = $('#confirm_password_feedback');

            let check = $('#check');
            let submit = $('#submit');

            username.keyup(function (e) {
                let value = e.target.value;
                checkAvailability({'username': value});
            });

            function checkAvailability(params) {
                $.ajax({
                    url: "/api/accounts/signup/check",
                    data: params,
                    type: 'get',
                    dataType: 'json',
                    success: function (data) {
                        let status = data['is_available'];
                        if (status) {
                            feedbackSuccess(username, usernameFeedback, 'Username tersedia');
                        } else {
                            feedbackError(username, usernameFeedback, 'Username tidak valid');
                        }
                    }
                });
            }

            function checkPassword(str) {
                let re = /^(?=.*[A-Z])(?=.*[!@#$%^&*])[a-zA-Z0-9!@#$%^&*]{8,}$/;
                return re.test(str);
            }

            function feedbackSuccess(element, elementFeedback, text) {
                element.removeClass('bd-red').addClass('bd-green');
                element.removeClass('is-invalid').addClass('is-valid');
                elementFeedback.removeClass('c-red').addClass('c-green');
                elementFeedback.text(text);
            }

            function feedbackError(element, elementFeedback, text) {
                element.removeClass('bd-green').addClass('bd-red');
                element.removeClass('is-valid').addClass('is-invalid');
                elementFeedback.removeClass('c-green').addClass('c-red');
                elementFeedback.text(text);
            }

            let passwords = $('#password,#confirm_password');
            passwords.keyup(function () {
                let passwordVal = password.val();
                let confirmPasswordVal = confirmPassword.val();
                let match = passwordVal === confirmPasswordVal;
                let valid = checkPassword(passwordVal);

                if (!valid) {
                    feedbackError(password, passwordFeedback, 'Harus minimal 8 karakter, 1 huruf besar, dan 1 karakter khusus');
                } else {
                    feedbackSuccess(password, passwordFeedback, '')
                }

                if (!match || confirmPasswordVal.length === 0) {
                    feedbackError(confirmPassword, confirmPasswordFeedback, 'Password tidak valid');
                } else {
                    feedbackSuccess(confirmPassword, confirmPasswordFeedback, '')
                }
            })

            check.change(function (e) {
                let checked = e.target.checked;
                if (checked) {
                    submit.removeAttr('disabled');
                } else {
                    submit.attr('disabled', true);
                }
            })


            let passwordIcon = $('#password_icon,#confirm_password_icon');
            passwordIcon.click(function () {
                let inputPassword = $(this).siblings().first();
                let inputPasswordType = inputPassword.attr('type');

                if (inputPasswordType === 'text') {
                    inputPassword.attr('type', 'password');
                    $(":first-child", $(this)).removeClass('bi-eye-slash').addClass('bi-eye');
                } else {
                    inputPassword.attr('type', 'text');
                    $(":first-child", $(this)).removeClass('bi-eye').addClass('bi-eye-slash');
                }
            });
        });
    </script>
{% endblock %}